diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/client.h ircd-hybrid-6.0/include/client.h
--- ircd-hybrid-6.0.orig/include/client.h	Fri Jun  8 18:03:39 2001
+++ ircd-hybrid-6.0/include/client.h	Fri Jun  8 16:07:44 2001
@@ -105,6 +105,37 @@
   struct Client*   users;       /* Users on this server */
 };
 
+/* DO NOT change this without changing the bitfield macros */
+typedef u_int32_t umode_t[2];
+
+/* Support stuff for the umode bitfields */
+#define BITFIELD_SIZE 64
+
+struct bitfield_lookup_t {
+  int field;
+  u_int32_t bit;
+};
+
+/* This is initialised in init_umodes() in s_user.c, based on the value of BITFIELD_SIZE */
+extern struct bitfield_lookup_t bitfield_lookup[];
+
+#define SetBit(f,b)   (((f)[bitfield_lookup[b].field]) |=  bitfield_lookup[b].bit)
+#define ClearBit(f,b) (((f)[bitfield_lookup[b].field]) &= ~bitfield_lookup[b].bit)
+#define TestBit(f,b)  (((f)[bitfield_lookup[b].field]) &  bitfield_lookup[b].bit)
+
+/* Written out in full for speed.
+ * I never thought I would actually use the , operator. You live and learn.
+ *  -- asuffield
+ */
+#define CopyUmodes(d,s) ((d[0] = s[0]), (d[1] = s[1]))
+#define AndUmodes(d,a,b) ((d[0] = a[0] & b[0]), (d[1] = a[1] & b[1]))
+#define OrUmodes(d,a,b) ((d[0] = a[0] | b[0]), (d[1] = a[1] | b[1]))
+#define AndNotUmodes(d,a,b) ((d[0] = a[0] & ~b[0]), (d[1] = a[1] & ~b[1]))
+#define NotUmodes(d,s) ((d[0] = ~s[0]), (d[1] = ~s[1]))
+#define AnyBits(d) (d[0] | d[1])
+
+#define ClearBitfield(b) ((b[0] = 0), (b[1] = 0))
+
 struct Client
 {
   struct Client*    next;
@@ -139,7 +170,8 @@
   time_t            firsttime;  /* time client was created */
   time_t            since;      /* last time we parsed something */
   time_t            tsinfo;     /* TS on the nick, SVINFO on server */
-  u_int32_t         umodes;     /* opers, normal users subset */
+  umode_t           umodes;     /* opers, normal users subset. DO NOT change this number without editing the bitfield macros below */
+  umode_t   allowed_umodes;     /* umodes which may be set outside of USER_UMODES */
   u_int32_t         flags;      /* client flags */
   u_int32_t         flags2;     /* ugh. overflow */
   int               fd;         /* >= 0, for local clients */
@@ -320,33 +352,62 @@
 #define FLAGS_IPHASH       0x1000 /* iphashed this client */
 
 /* umodes, settable flags */
-#define FLAGS_SERVNOTICE   0x00001 /* server notices such as kill */
-#define FLAGS_CCONN        0x00002 /* Client Connections */
-#define FLAGS_REJ          0x00004 /* Bot Rejections */
-#define FLAGS_SKILL        0x00008 /* Server Killed */
-#define FLAGS_FULL         0x00010 /* Full messages */
-#define FLAGS_SPY          0x00020 /* see STATS / LINKS */
-#define FLAGS_DEBUG        0x00040 /* 'debugging' info */
-#define FLAGS_NCHANGE      0x00080 /* Nick change notice */
-#define FLAGS_WALLOP       0x00100 /* send wallops to them */
-#define FLAGS_OPERWALL     0x00200 /* Operwalls */
-#define FLAGS_INVISIBLE    0x00400 /* makes user invisible */
-#define FLAGS_BOTS         0x00800 /* shows bots */
-#define FLAGS_EXTERNAL     0x01000 /* show servers introduced */
-#define FLAGS_NINVITE      0x40000 /* Don't send or receive INVITE messages -- PMA */
-#define FLAGS_NCTCP        0x200000 /* Don't receive CTCP messages or notices -- PMA */
+/* Nice, flashy new bitfield math. These are just indexes into the lookup. Fun :)
+ *  -- asuffield */
+#define UMODE_INVALID         0 /* Used as a delimeter in lists */
+#define UMODE_SERVNOTICE      1 /* server notices such as kill */
+#define UMODE_CCONN           2 /* Client Connections */
+#define UMODE_REJ             3 /* Bot Rejections */
+#define UMODE_SKILL           4 /* Server Killed */
+#define UMODE_FULL            5 /* Full messages */
+#define UMODE_SPY             6 /* see STATS / LINKS */
+#define UMODE_DEBUG           7 /* 'debugging' info */
+#define UMODE_NCHANGE         8 /* Nick change notice */
+#define UMODE_WALLOP          9 /* send wallops to them */
+#define UMODE_OPERWALL       10 /* Operwalls */
+#define UMODE_INVISIBLE      11 /* makes user invisible */
+#define UMODE_BOTS           12 /* shows bots */
+#define UMODE_EXTERNAL       13 /* show servers introduced */
+#define UMODE_NINVITE        14 /* Don't send or receive INVITE messages -- PMA */
+#define UMODE_NCTCP          15 /* Don't receive CTCP messages or notices -- PMA */
 
 /* user information flags, only settable by remote mode or local oper */
-#define FLAGS_IMMUNE       0x02000 /* immune from kick/deop */
-#define FLAGS_OPER         0x04000 /* Operator */
-#define FLAGS_LOCOP        0x08000 /* Local operator -- SRB */
-#define FLAGS_AUSPEX       0x10000 /* See the invisible. */
-#define FLAGS_IDENTIFIED   0x20000 /* Registered and identified with NickServ -- MGS */
-#define FLAGS_CHCREATE    0x80000 /* Channel Creation Notices */
-#define FLAGS_BLOCK_NOTID   0x100000 /* Block messages from non-identified users */
-
-#define FLAGS_GOD          0x400000 /* greater deity */
-/* Last flag is 0x80000000 for 32-bit unsigned int */
+/* No longer; these are now privileges proper. You can only gain them
+ * if your O:line says you can.
+ *  -- asuffield
+ */
+#define UMODE_IMMUNE         16 /* immune from kick/deop */
+#define UMODE_OPER           17 /* Operator */
+#define UMODE_LOCOP          18 /* Local operator -- SRB */
+#define UMODE_AUSPEX         19 /* See the invisible. */
+#define UMODE_IDENTIFIED     20 /* Registered and identified with NickServ -- MGS */
+#define UMODE_CHCREATE       21 /* Channel Creation Notices */
+#define UMODE_BLOCK_NOTID    22 /* Block messages from non-identified users */
+
+#define UMODE_GOD            23 /* greater deity */
+#define UMODE_GLOBAL_KILL    24
+#define UMODE_REMOTE         25 /* CONNECT, SQUIT */
+#define UMODE_GLINE          26
+#define UMODE_KILL           27 /* KILL, KLINE */
+#define UMODE_DIE            28
+#define UMODE_REHASH         29
+#define UMODE_UNKLINE        30
+#define UMODE_SEESOPERS      31
+#define UMODE_FLUDPROOF      32
+#define UMODE_MASSNOTICE     33
+#define UMODE_SEEILINES      34
+#define UMODE_SEEKLINES      35
+#define UMODE_SEEQLINES      36
+#define UMODE_SEESTATST      37
+#define UMODE_SEESTATSSERV   38
+#define UMODE_TESTLINE       39
+#define UMODE_FORCELUSERS    40
+#define UMODE_ANYNICK        41
+#define UMODE_SENDWALLOPS    42
+#define UMODE_SETNAME        43
+#define UMODE_HIGHPRIORITY   44
+#define UMODE_GRANT          45
+#define UMODE_SENDOPERWALL   46
 
 /* *sigh* overflow flags */
 #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
@@ -356,32 +417,6 @@
 #define FLAGS2_F_LINED      0x0010      /* client is graced with F line */
 #define FLAGS2_EXEMPTGLINE  0x2000      /* client can't be G-lined */
 
-/* oper priv flags */
-#define FLAGS2_OPER_GLOBAL_KILL 0x0020  /* oper can global kill */
-#define FLAGS2_OPER_REMOTE      0x0040  /* oper can do squits/connects */
-#define FLAGS2_OPER_UNKLINE     0x0080  /* oper can use unkline */
-#define FLAGS2_OPER_GLINE       0x0100  /* oper can use gline */
-#define FLAGS2_OPER_N           0x0200  /* oper can umode n */
-#define FLAGS2_OPER_K           0x0400  /* oper can kill/kline */
-#define FLAGS2_OPER_DIE         0x0800  /* oper can die */
-#define FLAGS2_OPER_REHASH      0x1000  /* oper can rehash */
-#define FLAGS2_OPER_IMMUNE	0x2000	/* oper can umode m */
-#define FLAGS2_OPER_AUSPEX	0x800000 /* oper can see the invisible */
-#define FLAGS2_OPER_CHCREATE	0x2000000 /* oper sees local chan creations */
-					 /* Careful of the numbering if you add another flag... */
-#define FLAGS2_OPER_GOD         0x4000000 /* oper can have an apotheosis */
-#define FLAGS2_OPER_FLAGS       (FLAGS2_OPER_GLOBAL_KILL | \
-                                 FLAGS2_OPER_GOD | \
-                                 FLAGS2_OPER_REMOTE | \
-                                 FLAGS2_OPER_UNKLINE | \
-                                 FLAGS2_OPER_GLINE | \
-                                 FLAGS2_OPER_N | \
-                                 FLAGS2_OPER_K | \
-                                 FLAGS2_OPER_DIE | \
-                                 FLAGS2_OPER_REHASH | \
-                                 FLAGS2_OPER_IMMUNE | \
-                                 FLAGS2_OPER_AUSPEX | \
-                                 FLAGS2_OPER_CHCREATE)
 /* ZIP_LINKS */
 
 #define FLAGS2_ZIP           0x4000  /* (server) link is zipped */
@@ -398,33 +433,20 @@
                                                    from non opers */
 #define FLAGS2_SENDQ_POP  0x400000  /* sendq exceeded (during list) */
 
-
-#define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | \
-                      FLAGS_IMMUNE | FLAGS_IDENTIFIED | FLAGS_NINVITE | \
-                      FLAGS_BLOCK_NOTID | FLAGS_NCTCP)
-/*
- * Only opers can have modes outside USER_UMODES.  If you change this
- * set, then also change the explanatory NOTICE in user_mode(). -dark
+/**********
+ * NOTICE *
+ **********
+ *
+ * send_umodes and user_umodes are now defined in a roundabout way in
+ *  init_umodes() at the bottom of s_user.c. This is a compromise; the
+ *  rest of the bitfield math works much neater this way. Suggestions of
+ *  better ways to do it welcome.
+ *   -- asuffield
  */
-#define USER_UMODES  (FLAGS_INVISIBLE | FLAGS_WALLOP | FLAGS_NINVITE | \
-                      FLAGS_BLOCK_NOTID | FLAGS_NCTCP)
-#define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
-                      FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
-                      FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
-                      FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOP | \
-                      FLAGS_GOD | FLAGS_IMMUNE | FLAGS_AUSPEX | \
-                      FLAGS_IDENTIFIED | FLAGS_CHCREATE | FLAGS_BLOCK_NOTID)
-
-#ifndef OPER_UMODES
-#define OPER_UMODES  (FLAGS_OPER | FLAGS_WALLOP | FLAGS_SERVNOTICE | \
-                      FLAGS_SPY | FLAGS_OPERWALL | FLAGS_DEBUG | FLAGS_BOTS \
-                      FLAGS_CHCREATE)
-#endif /* OPER_UMODES */
-
-#ifndef LOCOP_UMODES
-#define LOCOP_UMODES (FLAGS_LOCOP | FLAGS_WALLOP | FLAGS_SERVNOTICE | \
-                      FLAGS_SPY | FLAGS_DEBUG | FLAGS_BOTS)
-#endif /* LOCOP_UMODES */
+
+extern umode_t send_umodes;
+extern umode_t user_umodes;
+extern umode_t all_umodes;
 
 #define FLAGS_ID     (FLAGS_NEEDID | FLAGS_GOTID)
 
@@ -443,53 +465,78 @@
 
 /* oper flags */
 #define MyOper(x)               (MyConnect(x) && IsOper(x))
-#define IsOper(x)               ((x)->umodes & FLAGS_OPER)
+#define IsOper(x)               (TestBit((x)->umodes,UMODE_OPER))
 #ifdef GODOPERS
-#define IsGodOper(x)            ((x)->umodes & FLAGS_GOD)
+#define IsGodOper(x)            (TestBit((x)->umodes,UMODE_GOD))
 #else
 #define IsGodOper(x)            0
 #endif
-#define IsLocOp(x)              ((x)->umodes & FLAGS_LOCOP)
-#define IsAnOper(x)             ((x)->umodes & (FLAGS_OPER|FLAGS_LOCOP))
-#define SetOper(x)              ((x)->umodes |= FLAGS_OPER)
-#define SetLocOp(x)             ((x)->umodes |= FLAGS_LOCOP)
-#define ClearOper(x)            ((x)->umodes &= ~FLAGS_OPER)
-#define ClearLocOp(x)           ((x)->umodes &= ~FLAGS_LOCOP)
+#define IsLocOp(x)              (TestBit((x)->umodes,UMODE_LOCOP))
+#define IsAnOper(x)             (IsOper(x) || IsLocOp(x))
+#define SetOper(x)              (SetBit((x)->umodes,UMODE_OPER))
+#define SetLocOp(x)             (SetBit((x)->umodes,UMODE_LOCOP))
+#define ClearOper(x)            (ClearBit((x)->umodes,UMODE_OPER))
+#define ClearLocOp(x)           (ClearBit((x)->umodes,UMODE_LOCOP))
 #define IsPrivileged(x)         (IsAnOper(x) || IsServer(x))
 
 /* umode flags */
-#define IsInvisible(x)          ((x)->umodes & FLAGS_INVISIBLE)
-#define SetInvisible(x)         ((x)->umodes |= FLAGS_INVISIBLE)
-#define ClearInvisible(x)       ((x)->umodes &= ~FLAGS_INVISIBLE)
-#define BlocksInvites(x)        ((x)->umodes & FLAGS_NINVITE)
-#define SetNoInvites(x)         ((x)->umodes |= FLAGS_NINVITE)
-#define ClearNoInvites(x)       ((x)->umodes &= ~FLAGS_NINVITE)
-#define DoesNotCTCP(x)          ((x)->umodes & FLAGS_NCTCP)
-#define SendWallops(x)          (((x)->umodes & FLAGS_WALLOP) && IsAnOper(x))
-#define ClearWallops(x)         ((x)->umodes &= ~FLAGS_WALLOP)
-#define SendServNotice(x)       (((x)->umodes & FLAGS_SERVNOTICE) && IsAnOper(x))
-#define SendOperwall(x)         ((x)->umodes & FLAGS_OPERWALL)
-#define SendCConnNotice(x)      ((x)->umodes & FLAGS_CCONN)
-#define SendRejNotice(x)        ((x)->umodes & FLAGS_REJ)
-#define SendSkillNotice(x)      ((x)->umodes & FLAGS_SKILL)
-#define SendFullNotice(x)       ((x)->umodes & FLAGS_FULL)
-#define SendSpyNotice(x)        ((x)->umodes & FLAGS_SPY)
-#define SendDebugNotice(x)      ((x)->umodes & FLAGS_DEBUG)
-#define SendNickChange(x)       ((x)->umodes & FLAGS_NCHANGE)
-#define SetWallops(x)           ((x)->umodes |= FLAGS_WALLOP)
-#define IsImmune(x)             ((x)->umodes & FLAGS_IMMUNE)
+#define IsInvisible(x)          (TestBit((x)->umodes,UMODE_INVISIBLE))
+#define BlocksInvites(x)        (TestBit((x)->umodes,UMODE_NINVITE))
+#define DoesNotCTCP(x)          (TestBit((x)->umodes,UMODE_NCTCP))
+#define SendOperwall(x)         (TestBit((x)->umodes,UMODE_SENDOPERWALL))
+#define ReceiveOperwall(x)      (TestBit((x)->umodes,UMODE_OPERWALL))
+#define SendCConnNotice(x)      (TestBit((x)->umodes,UMODE_CCONN))
+#define SendRejNotice(x)        (TestBit((x)->umodes,UMODE_REJ))
+#define SendSkillNotice(x)      (TestBit((x)->umodes,UMODE_SKILL))
+#define SendFullNotice(x)       (TestBit((x)->umodes,UMODE_FULL))
+#define SendSpyNotice(x)        (TestBit((x)->umodes,UMODE_SPY))
+#define IsDebugger(x)           (TestBit((x)->umodes,UMODE_DEBUG))
+#define SendNickChange(x)       (TestBit((x)->umodes,UMODE_NCHANGE))
+#define IsImmune(x)             (TestBit((x)->umodes,UMODE_IMMUNE))
 
 #ifdef CHANNEL_CREATION_NOTICE
-#define SeesChannelCreations(x) ((x)->umodes & FLAGS_CHCREATE)
+#define SeesChannelCreations(x) (TestBit((x)->umodes,UMODE_CHCREATE))
 #endif
 
-#define SeesAllConnections(x)	((x)->umodes & FLAGS_AUSPEX)
-#define IsIdentifiedNick(x)     ((x)->umodes & FLAGS_IDENTIFIED)
-#define SetIdentifiedNick(x)    ((x)->umodes |= FLAGS_IDENTIFIED)
-#define ClearIdentifiedNick(x)  ((x)->umodes &= ~FLAGS_IDENTIFIED)
-#define IsBlockingUnidented(x)  ((x)->umodes & FLAGS_BLOCK_NOTID)
-#define SetBlockingUnidented(x) ((x)->umodes |= FLAGS_BLOCK_NOTID)
-#define ClearBlockingUnidented(x) ((x)->umodes &= ~FLAGS_BLOCK_NOTID)
+#define SeesOperMessages(x)     (TestBit((x)->umodes,UMODE_OPER))
+#define SeesOpers(x)            (TestBit((x)->umodes,UMODE_SEESOPERS))
+#define SendWhileLifeSucks(x)   (TestBit((x)->umodes,UMODE_HIGHPRIORITY))
+#define IsAlwaysBusy(x)         (TestBit((x)->umodes,UMODE_HIGHPRIORITY))
+/* This one means no protection against *this* client flooding */
+#define NoFloodProtection(x)    (TestBit((x)->umodes,UMODE_FLUDPROOF))
+#define CanSendMassNotice(x)    (TestBit((x)->umodes,UMODE_MASSNOTICE))
+#define CanSeeBlines(x)         (TestBit((x)->umodes,UMODE_SEEILINES))
+#define CanSeeDlines(x)         (TestBit((x)->umodes,UMODE_SEEKLINES))
+#define CanSeeElines(x)         (TestBit((x)->umodes,UMODE_SEEILINES))
+#define CanSeeFlines(x)         (TestBit((x)->umodes,UMODE_SEEILINES))
+#define CanSeeGlines(x)         (TestBit((x)->umodes,UMODE_SEEKLINES))
+#define CanSeeIlines(x)         (TestBit((x)->umodes,UMODE_SEEILINES))
+#define CanSeeKlines(x)         (TestBit((x)->umodes,UMODE_SEEKLINES))
+#define CanSeeOlines(x)         (TestBit((x)->umodes,UMODE_SEESOPERS))
+#define CanSeeQlines(x)         (TestBit((x)->umodes,UMODE_SEEQLINES))
+#define CanSeeStatsT(x)         (TestBit((x)->umodes,UMODE_SEESTATST))
+#define CanSeeXlines(x)         (TestBit((x)->umodes,UMODE_SEEQLINES))
+#define CanSeeYlines(x)         (TestBit((x)->umodes,UMODE_SEEILINES))
+#define CanSeeStatsServinfo(x)  (TestBit((x)->umodes,UMODE_SEESTATSSERV))
+#define CanDoTestline(x)        (TestBit((x)->umodes,UMODE_TESTLINE))
+#define CanForceLusers(x)       (TestBit((x)->umodes,UMODE_FORCELUSERS))
+#define CannotBeQlined(x)       (TestBit((x)->umodes,UMODE_ANYNICK))
+#define CannotBeXlined(x)       (TestBit((x)->umodes,UMODE_ANYNICK))
+#define SendWallops(x)          (TestBit((x)->umodes,UMODE_SENDWALLOPS))
+#define SendServNotice(x)       (TestBit((x)->umodes,UMODE_SERVNOTICE))
+#define CanConnect(x)           (TestBit((x)->umodes,UMODE_REMOTE))
+#define CanDoSetname(x)         (TestBit((x)->umodes,UMODE_SETNAME))
+/* Changing another user's umode */
+#define CanChangeModes(x)       (TestBit((x)->umodes,UMODE_SETNAME))
+#define CanGrantModes(x)        (TestBit((x)->umodes,UMODE_GRANT))
+
+#define SeesAllConnections(x)	(TestBit((x)->umodes,UMODE_AUSPEX))
+#define IsIdentifiedNick(x)     (TestBit((x)->umodes,UMODE_IDENTIFIED))
+#define SetIdentifiedNick(x)    (SetBit((x)->umodes,UMODE_IDENTIFIED))
+#define ClearIdentifiedNick(x)  (ClearBit((x)->umodes,UMODE_IDENTIFIED))
+#define IsBlockingUnidented(x)  (TestBit((x)->umodes,UMODE_BLOCK_NOTID))
+/* #define SetBlockingUnidented(x) (SetBit((x)->umodes,UMODE_BLOCK_NOTID)) */
+/* #define ClearBlockingUnidented(x) (ClearBit((x)->umodes,UMODE_BLOCK_NOTID)) */
 
 #ifdef REJECT_HOLD
 #define IsRejectHeld(x)         ((x)->flags & FLAGS_REJECT_HOLD)
@@ -536,33 +583,20 @@
 #endif
 
 #ifdef GODOPERS
-#define SetOperGod(x)           ((x)->flags2 |= FLAGS2_OPER_GOD)
-#define IsSetOperGod(x)         ((x)->flags2 & FLAGS2_OPER_GOD)
+#define IsSetOperGod(x)         (TestBit((x)->umodes,UMODE_GOD))
 #endif
-#define SetOperGlobalKill(x)    ((x)->flags2 |= FLAGS2_OPER_GLOBAL_KILL)
-#define IsOperGlobalKill(x)     ((x)->flags2 & FLAGS2_OPER_GLOBAL_KILL)
-#define SetOperRemote(x)        ((x)->flags2 |= FLAGS2_OPER_REMOTE)
-#define IsOperRemote(x)         ((x)->flags2 & FLAGS2_OPER_REMOTE)
-#define SetOperUnkline(x)       ((x)->flags2 |= FLAGS2_OPER_UNKLINE)
-#define IsSetOperUnkline(x)     ((x)->flags2 & FLAGS2_OPER_UNKLINE)
-#define SetOperGline(x)         ((x)->flags2 |= FLAGS2_OPER_GLINE)
-#define IsSetOperGline(x)       ((x)->flags2 & FLAGS2_OPER_GLINE)
-#define SetOperN(x)             ((x)->flags2 |= FLAGS2_OPER_N)
-#define IsSetOperN(x)           ((x)->flags2 & FLAGS2_OPER_N)
-#define SetOperK(x)             ((x)->flags2 |= FLAGS2_OPER_K)
-#define IsSetOperK(x)           ((x)->flags2 & FLAGS2_OPER_K)
-#define SetOperDie(x)           ((x)->flags2 |= FLAGS2_OPER_DIE)
-#define IsOperDie(x)            ((x)->flags2 & FLAGS2_OPER_DIE)
-#define SetOperRehash(x)        ((x)->flags2 |= FLAGS2_OPER_REHASH)
-#define IsOperRehash(x)         ((x)->flags2 & FLAGS2_OPER_REHASH)
-#define IsSetOperM(x)           ((x)->flags2 & FLAGS2_OPER_IMMUNE)
-#define SetOperM(x)             ((x)->flags2 |= FLAGS2_OPER_IMMUNE)
-#define IsSetOperAuspex(x)	((x)->flags2 & FLAGS2_OPER_AUSPEX)
-#define SetOperAuspex(x)	((x)->flags2 |= FLAGS2_OPER_AUSPEX)
+#define IsSetOperGlobalKill(x)  (TestBit((x)->umodes,UMODE_GLOBAL_KILL))
+#define IsSetOperRemote(x)      (TestBit((x)->umodes,UMODE_REMOTE))
+#define IsSetOperUnkline(x)     (TestBit((x)->umodes,UMODE_UNKLINE))
+#define IsSetOperGline(x)       (TestBit((x)->umodes,UMODE_GLINE))
+#define IsSetOperK(x)           (TestBit((x)->umodes,UMODE_KILL))
+#define IsSetOperDie(x)         (TestBit((x)->umodes,UMODE_DIE))
+#define IsSetOperRehash(x)      (TestBit((x)->umodes,UMODE_REHASH))
+#define IsSetOperM(x)           (TestBit((x)->umodes,UMODE_IMMUNE))
+#define IsSetOperAuspex(x)	(TestBit((x)->umodes,UMODE_AUSPEX))
 
 #ifdef CHANNEL_CREATION_NOTICE
-#define IsSetOperChanCreate(x)	((x)->flags2 & FLAGS2_OPER_CHCREATE)
-#define SetOperChanCreate(x)	((x)->flags2 |= FLAGS2_OPER_CHCREATE)
+#define IsSetOperChanCreate(x)	(TestBit((x)->umodes,UMODE_CHCREATE))
 #endif
 
 #define CBurst(x)               ((x)->flags2 & FLAGS2_CBURST)
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/include/config.h	Fri Jun  8 17:30:27 2001
@@ -747,10 +747,17 @@
  *
  * OPER_IDLE allows operators to remain idle when they idle
  * beyond the idle limit
+ *
+ * OPER_IDLE is fundamentally opposed to the objective of
+ * removing all special powers from O:lines and moving to
+ * capabilities. Don't use it.
+ *  -- asuffield
  */
 #undef  IDLE_CHECK
 #define IDLE_TIME 20160
-#define OPER_IDLE
+/* (deprecated)
+ * #undef OPER_IDLE
+ */
 
 /* SEND_FAKE_KILL_TO_CLIENT - make the client think it's being /KILL'ed
  * 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/s_conf.h ircd-hybrid-6.0/include/s_conf.h
--- ircd-hybrid-6.0.orig/include/s_conf.h	Fri Jun  8 18:03:39 2001
+++ ircd-hybrid-6.0/include/s_conf.h	Wed Jun  6 18:30:41 2001
@@ -201,6 +201,7 @@
 #ifndef INCLUDED_motd_h
 #include "motd.h"               /* MessageFile */
 #endif
+#include "client.h"
 
 struct Client;
 struct SLink;
@@ -224,6 +225,8 @@
   time_t           hold;     /* Hold action until this time (calendar time) */
   struct Class*    c_class;     /* Class of connection */
   int              dns_pending; /* 1 if dns query pending, 0 otherwise */
+  umode_t          allowed_umodes;
+  umode_t          default_umodes;
 };
 
 typedef struct QlineItem {
@@ -317,21 +320,6 @@
 #define IsConfLittleI(x)        ((x)->flags & CONF_FLAGS_LITTLE_I_LINE)
 #endif
 
-/* port definitions for Opers */
-
-#define CONF_OPER_GLOBAL_KILL 1
-#define CONF_OPER_REMOTE      2
-#define CONF_OPER_UNKLINE     4
-#define CONF_OPER_GLINE       8
-#define CONF_OPER_N          16
-#define CONF_OPER_K          32
-#define CONF_OPER_REHASH     64
-#define CONF_OPER_DIE       128
-#define CONF_OPER_M         256
-#define CONF_OPER_AUSPEX    512
-#define CONF_OPER_CHCREATE 1024
-#define CONF_OPER_GOD      2048
-
 typedef struct
 {
   char *dpath;          /* DPATH if set from command line */
@@ -403,8 +391,7 @@
 extern struct ConfItem* find_conf_by_abbrevname(const char* name, int status);
 extern struct ConfItem* find_kill (struct Client *);
 extern int conf_connect_allowed(struct in_addr addr);
-extern char *oper_flags_as_string(int);
-extern char *oper_privs_as_string(struct Client *, int);
+extern char *oper_flags_as_string(umode_t);
 extern int rehash_dump(struct Client *);
 extern int find_q_line(char*, char*, char *);
 extern struct ConfItem* find_special_conf(char *,int );
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/s_user.h ircd-hybrid-6.0/include/s_user.h
--- ircd-hybrid-6.0.orig/include/s_user.h	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/include/s_user.h	Wed Jun  6 18:40:36 2001
@@ -31,20 +31,21 @@
 #include <sys/types.h>      /* time_t */
 #define INCLUDED_sys_types_h
 #endif
+#include "client.h"
 
 struct Client;
 #ifdef PACE_WALLOPS
 extern time_t LastUsedWallops;
 #endif
 
-
 extern int   user_mode(struct Client *, struct Client *, int, char **);
 extern void  send_umode (struct Client *, struct Client *,
-                         int, int, char *);
-extern void  send_umode_out (struct Client*, struct Client *, int);
+                         umode_t, umode_t, char *);
+extern void  send_umode_out (struct Client*, struct Client *, umode_t);
 extern int   show_lusers(struct Client *, struct Client *, int, char **);
 extern void  show_opers(struct Client* client);
 extern int   del_silence(struct Client *, char *);
 extern int   is_silenced(struct Client *, struct Client *);
+extern void  init_umodes();
 
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/send.h ircd-hybrid-6.0/include/send.h
--- ircd-hybrid-6.0.orig/include/send.h	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/include/send.h	Wed Jun  6 17:39:42 2001
@@ -55,10 +55,10 @@
 extern  void sendto_match_butone(struct Client *, struct Client *, 
                                  char *, int, const char *, ...);
 
-extern  void sendto_ops_flags(int, const char *, ...);
+extern  void sendto_ops_flag(int, const char *, ...);
 
 extern  void sendto_realops(const char *, ...);
-extern  void sendto_realops_flags(int, const char *, ...);
+extern  void sendto_realops_flag(int, const char *, ...);
 
 extern  void sendto_ops(const char *, ...);
 extern  void sendto_ops_butone(struct Client *, struct Client *, 
@@ -78,6 +78,6 @@
 #define MATCH_SERVER  1
 #define MATCH_HOST    2
 
-extern  void sendto_ops_flags_butone(struct Client *, int, const char *, ...);
+extern  void sendto_ops_flag_butone(struct Client *, int, const char *, ...);
 
 #endif /* INCLUDED_send_h */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/umodes.h ircd-hybrid-6.0/include/umodes.h
--- ircd-hybrid-6.0.orig/include/umodes.h	Thu Jan  1 01:00:00 1970
+++ ircd-hybrid-6.0/include/umodes.h	Fri Jun  8 16:07:21 2001
@@ -0,0 +1,94 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, include/s_user.h
+ *   This file is copyright (C) 2001 Andrew Suffield
+ *                                    <asuffield@users.sourceforge.net>
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 2 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ */
+#ifndef INCLUDED_s_umodes_h
+#define INCLUDED_s_umodes_h
+#ifndef INCLUDED_config_h
+#include "config.h"
+#endif
+#ifndef INCLUDED_sys_types_h
+#include <sys/types.h>      /* time_t */
+#define INCLUDED_sys_types_h
+#endif
+
+#include "common.h"
+#include "client.h"
+
+/* table of ascii char letters to corresponding bitmask */
+
+static FLAG_ITEM user_modes[] =
+{ 
+  {UMODE_AUSPEX, 'a'},
+  {UMODE_BOTS,  'b'},
+  {UMODE_CCONN, 'c'},
+  {UMODE_NCTCP, 'C'},
+  {UMODE_DEBUG, 'd'},
+  {UMODE_DIE, 'D'},
+  {UMODE_IDENTIFIED, 'e'},
+  {UMODE_BLOCK_NOTID, 'E'},
+  {UMODE_FULL,  'f'},
+  {UMODE_FLUDPROOF, 'F'},
+  {UMODE_GLINE, 'g'},
+  {UMODE_GLOBAL_KILL, 'G'},
+  {UMODE_HIGHPRIORITY, 'h'},
+  {UMODE_REHASH, 'H'},
+  {UMODE_INVISIBLE, 'i'},
+  {UMODE_NINVITE, 'I'},
+  {UMODE_SKILL, 'k'},
+  {UMODE_KILL, 'K'},
+#ifdef CHANNEL_CREATION_NOTICE
+  {UMODE_CHCREATE, 'l'},
+#endif
+  {UMODE_FORCELUSERS, 'L'},
+  {UMODE_IMMUNE, 'm'},
+  {UMODE_MASSNOTICE, 'M'},
+  {UMODE_NCHANGE, 'n'},
+  {UMODE_ANYNICK, 'N'},
+  {UMODE_OPER, 'o'},
+  {UMODE_LOCOP, 'O'},
+#ifdef GODOPERS
+  {UMODE_GOD,   'p'},
+#endif
+  {UMODE_SETNAME, 'P'},
+  {UMODE_REJ, 'r'},
+  {UMODE_REMOTE, 'R'},
+  {UMODE_SERVNOTICE, 's'},
+  {UMODE_UNKLINE, 'U'},
+  {UMODE_WALLOP, 'w'},
+  {UMODE_SENDWALLOPS, 'W'},
+  {UMODE_EXTERNAL, 'x'},
+  {UMODE_SPY, 'y'},
+  {UMODE_OPERWALL, 'z'},
+  {UMODE_SENDOPERWALL, 'Z'},
+  {UMODE_SEESOPERS, '0'},
+  {UMODE_SEEILINES, '1'},
+  {UMODE_SEEKLINES, '2'},
+  {UMODE_SEEQLINES, '3'},
+  {UMODE_SEESTATST, '4'},
+  {UMODE_SEESTATSSERV,'5'},
+  {UMODE_TESTLINE, '9'},
+  {UMODE_GRANT, '*'},
+  {0, 0}
+};
+
+/* There is no reason why this cannot be calculated at runtime -- asuffield */
+extern int user_modes_from_c_to_bitmask[];
+
+#endif
